diff --git a/src/backend/commands/vacuumparallel.c b/src/backend/commands/vacuumparallel.c
index 5dd70c5273..8c70efcefa 100644
--- a/src/backend/commands/vacuumparallel.c
+++ b/src/backend/commands/vacuumparallel.c
@@ -138,7 +138,7 @@ typedef struct PVIndStats
 } PVIndStats;
 
 /* Struct for maintaining a parallel vacuum state. */
-typedef struct ParallelVacuumState
+struct ParallelVacuumState
 {
 	/* NULL for worker processes */
 	ParallelContext *pcxt;
@@ -195,7 +195,7 @@ typedef struct ParallelVacuumState
 	char	   *relname;
 	char	   *indname;
 	PVIndVacStatus status;
-} ParallelVacuumState;
+};
 
 static int	parallel_vacuum_compute_workers(Relation *indrels, int nindexes, int nrequested,
 											bool *will_parallel_vacuum);